# ToDo Project / React App

This project was bootstrapped with [Create React App](https://github.com/facebook/create-react-app).

## Available Scripts

In the project directory, you can run:

### `npm start`

Runs the app in the development mode.\
Open [http://localhost:3000](http://localhost:3000) to view it in the browser.

The page will reload if you make edits.\
You will also see any lint errors in the console.

### `npm test`

Launches the test runner in the interactive watch mode.\
See the section about [running tests](https://facebook.github.io/create-react-app/docs/running-tests) for more information.

### `npm run build`

Builds the app for production to the `build` folder.\
It correctly bundles React in production mode and optimizes the build for the best performance.

The build is minified and the filenames include the hashes.\
Your app is ready to be deployed!

## Kubernetes Deployment

### `helm install todo-gui-deploy todo-gui deploy`

The folder named todo-gui-deploy includes all yaml files for kubernetes deployment. It can be used as `kubectl apply -f todo-gui.yaml` in todo-gui-deploy/templates.

## CI/CD

In this project, we use gitlab, and as you can see, there is a `.gitlab-ci.yml` file in main directory. For now, there are 5 stages in this pipeline, these are build, test, containerize, deploy, acceptance.

Also there is a `Dockerfile` for create a docker image. When project pushed to gitlab, in contanerize stage, this dockerfile builded and saved to gitlab registry as registry.gitlab.com/learnfast/todo/todo-gui.
